<template>
  <div class="cta">
    <div v-if="variation" class="cta__cupon">
      <div class="cta__cupon__title">
        Kupon
      </div>
      <template v-if="product.variations.length > 1">
        <div class="select js-select">
          <div class="select__label js-select-label">
            <div class="select__label__content">
              <div><span v-if="variation.attributes.attribute_pa_pakage === `five`">5x</span>
                {{ variation.attributes.attribute_pa_time }}
              </div>
              <div>{{ variation.display_price }} zł</div>
            </div>
            <svg xmlns="http://www.w3.org/2000/svg" width="13.852" height="8.691" viewBox="0 0 13.852 8.691">
              <g id="Group_4989" data-name="Group 4989" transform="translate(8.061 1.061)">
                <line id="Line_1" data-name="Line 1" x2="6.57" y2="6.57" transform="translate(-7)" fill="none"
                      stroke="#97c35b" stroke-width="3"/>
                <line id="Line_2" data-name="Line 2" x1="6.57" y2="6.57" transform="translate(-1.84)" fill="none"
                      stroke="#97c35b" stroke-width="3"/>
              </g>
            </svg>
          </div>
          <div class="select__list">
            <div v-for="variationItem in product.variations" class="select__list__item js-select-item"
                 @click="variation = variationItem;">
              <div><span v-if="variationItem.attributes.attribute_pa_pakage === `five`">5x</span>
                {{ variationItem.attributes.attribute_pa_time }}
              </div>
              <div>{{ variationItem.display_price }} zł</div>
            </div>
          </div>
        </div>
      </template>
      <template v-else>
        <div class="select">
          <div class="select__label single">
            <div class="select__label__content">
              <div><span v-if="variation.attributes.attribute_pa_pakage === `five`">5x</span>
                {{ variation.attributes.attribute_pa_time }}
              </div>
              <div>{{ variation.display_price }} zł</div>
            </div>
          </div>
        </div>
      </template>
    </div>
    <div class="cta__add-to-cart">
      <div class="cta__add-to-cart__title">
        Ilość
      </div>
      <div class="cta__add-to-cart__content">
        <div class="counter">
          <div class="counter__minus" @click="setCount(parseInt(quantity - 1), false)">
            -
          </div>
          <div class="counter__number">
            {{ quantity }}
          </div>
          <div class="counter__plus" @click="setCount(parseInt(quantity + 1), true)">
            +
          </div>
        </div>
        <button @click="handleClick" class="button button--green">
          Dodaj do koszyka
        </button>
      </div>
    </div>
    <div v-if="success" class="cta__added">Produkt został dodany do koszyka. <a :href="links.cart_url" title="Przejdź do koszyka">Przejdź do koszyka</a></div>
  </div>
</template>

<script>

export default {
  props: {
    product: {
      type: Object,
      required: true
    },
    links: {
      type: Object,
      required: true,
    },
  },
  data() {
    return {
      variation: this.product.variations[0],
      quantity: 1,
      success: false
    }
  },
  methods: {
    setCount(value, trigger) {
      if (value < 1) {
        return
      }

      if (trigger) this.quantity = value
      else this.quantity = value
    },
    async handleClick() {
      const res = await this.$store.dispatch('AJAX_ADD_TO_CART', {
        id: this.product.id,
        quantity: this.quantity,
        attributes: this.variation.attributes,
      })

      if (res) {
        if (res.data.cart && Array.isArray(res.data.cart.products))
          document.querySelector('.js-count-cart-products').innerHTML = `${res.data.cart.products.length}`
        this.success = res.success
      }
    },
  }
}
</script>
